rawset(_G, "hasShield", function(p, shield)
	if p.powers[pw_super] then return false end

	return (p.powers[pw_shield] & SH_NOSTACK) == shield
end)

rawset(_G, "Blossom_Misc", function(p)
	if not p.mo or not p.mo.valid then return end

	-- lmao
	if p.playerstate ~= PST_DEAD then
		if p.mo.blossom_tanukianim then
			p.mo.color = p.skincolor
			p.mo.colorized = false
			p.mo.blossom_tanukianim = $-1

			p.mo.spritexscale = 2*FRACUNIT
			p.mo.spriteyscale = 2*FRACUNIT
			p.mo.spriteyoffset = 10*FRACUNIT

			if p.mo.blossom_tanukianim <= 0 then
				p.tanukisuit = not p.tanukisuit
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				p.mo.spriteyoffset = 0
				p.mo.sprite = SPR_PLAY
				p.mo.blossom_tanukianim = nil
			end
		elseif p.tanukisuit then
			p.drawangle = p.mo.angle

			if P_IsObjectOnGround(p.mo) then
				if not (leveltime%20) then P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST) end
				if p.speed > 0 and not S_SoundPlaying(p.mo, sfx_statu2) then S_StartSound(p.mo, sfx_statu2) end

				if not p.mo.blossom_slamsound then
					p.mo.blossom_slamsound = true

					local x, y, dust
					for i = 1, 16 do
						x = 48*cos(i*ANGLE_22h)
						y = 48*sin(i*ANGLE_22h)
						dust = P_SpawnMobjFromMobj(p.mo, x, y, 8*FRACUNIT, MT_SPINDUST)
						dust.scale = 2*FRACUNIT
					end

					if p == displayplayer then
						P_StartQuake(32*FRACUNIT, 10, {p.mo.x, p.mo.y, p.mo.z}, 512*FRACUNIT)
						S_StartSound(p.mo, sfx_tf2pan)
					end
				end
			else
				p.mo.blossom_slamsound = nil
			end
		end
	end

	-- ok if we're not blossom lets not do anymore
	if p.mo.skin ~= "blossom" then
		p.mo.blossom_didsuper = nil
		p.mo.blossom_didsuper_horizontal = nil
		p.mo.blossom_autospringremove = nil
		p.mo.blossom_wallslide = nil
		p.mo.blossom_superjump = nil
		p.mo.blossom_notonwall = nil
		p.mo.blossom_cancelled = nil
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_slidetimer = nil

		if p.mo.targvine then
			if p.mo.targvine[1] and p.mo.targvine[1].valid then P_RemoveMobj(p.mo.targvine[1]) end
			p.mo.targvine = nil
		end

		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil

		if p.mo.blossom_fastfall then
			p.mo.blossom_fastfall = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end

		if p.mo.blossom_duckdance then
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		end

		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
		if S_SoundPlaying(p.mo, sfx_uigoku) then
			S_StopSoundByID(p.mo, sfx_uigoku)
			S_ResumeMusic(p)
		end

		return
	end

	if p.mo.blossom_invinc then
		p.mo.blossom_invinc = $-1
		if p.mo.blossom_invinc <= 0 then p.mo.blossom_invinc = nil end
	end

	if p.playerstate == PST_DEAD or P_PlayerInPain(p) or p.powers[pw_carry] then
		p.mo.blossom_didsuper = nil
		p.mo.blossom_didsuper_horizontal = nil
		p.mo.blossom_autospringremove = nil
		p.mo.blossom_wallslide = nil
		p.mo.blossom_superjump = nil
		p.mo.blossom_notonwall = nil
		p.notornado = nil
		p.notornadogrounded = nil
		p.mo.blossom_cancelled = nil
		p.mo.spin_stuff = nil
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_slidetimer = nil

		if p.mo.targvine then
			if p.mo.targvine[1] and p.mo.targvine[1].valid then P_RemoveMobj(p.mo.targvine[1]) end
			p.mo.targvine = nil
		end

		p.mo.backup = nil
		p.mo.targvine = nil
		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil

		if p.mo.blossom_fastfall then
			p.mo.blossom_fastfall = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end

		if p.mo.blossom_duckdance then
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		end

		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
		if S_SoundPlaying(p.mo, sfx_uigoku) then
			S_StopSoundByID(p.mo, sfx_uigoku)
			S_ResumeMusic(p)
		end

		p.mo.flags = $ & ~MF_NOGRAVITY
	end

	if (p.mo.state == S_PLAY_BLOSSOM_TORNADO) then p.drawangle = (leveltime*ANG20) end

	-- Grounded resets
	if P_IsObjectOnGround(p.mo) then
		p.notornadogrounded = nil
		p.mo.blossom_cancelled = nil
		p.mo.blossom_didtwirl = nil
		p.mo.blossom_twirltimer = nil
		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil
	end

	-- Idle
	if p.mo.blossom_isidling then
		p.mo.blossom_dothings = $ and $+1 or 1
		if p.mo.blossom_dothings >= 35 then p.mo.blossom_dothings = 0 end

		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.state = S_PLAY_WALK
			if p.mo.momz > 0 then p.mo.state = S_PLAY_SPRING end
			p.mo.blossom_waittimer = nil
			p.mo.blossom_isidling = nil
			p.mo.blossom_dothings = nil
			p.drawangle = p.mo.angle - ANGLE_180
		else
			p.mo.sprite2 = SPR2_MLEE
			p.mo.frame = (p.mo.blossom_isidling.frame or 0) + (p.mo.blossom_dothings >= 17 and 1 or 0)
		end
	elseif p.mo.blossom_waittimer then
		p.mo.state = S_PLAY_STND
		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.blossom_waittimer = nil
			p.mo.blossom_isidling = nil
			p.mo.blossom_dothings = nil
		else
			p.mo.blossom_waittimer = $ and $+1 or 1

			if p.mo.blossom_waittimer <= 16 then
				p.mo.sprite2 = SPR2_TWIN
				p.mo.frame = min(3, max(0, (p.mo.blossom_waittimer/4)-1))
			else
				p.mo.blossom_waittimer = nil

				local chance = P_RandomRange(1, 100)

				local rarity = 3
				if chance <= 12 then rarity = ((chance <= 2) and 1 or 2) end

				local flowers = Blossom_FlowerTypes[rarity]
				p.mo.blossom_isidling = flowers[P_RandomRange(1, #flowers)]

				if p.mo.blossom_isidling then
					if p.mo.blossom_isidling.nothing then return end

					if p.mo.blossom_isidling.sound then
						S_StartSound(p.mo, p.mo.blossom_isidling.sound)
					else
						S_StartSound(p.mo, sfx_hoop3)
					end

					if rarity == 2 then S_StartSound(p.mo, sfx_ncitem) end
					if rarity == 1 then S_StartSound(p.mo, sfx_ideya) end
				end
			end
		end
	else
		if p.mo.state == S_PLAY_WAIT and not p.tanukisuit and not p.mo.blossom_tanukianim then p.mo.blossom_waittimer = 1 end
	end

	-- Duck Dance
	if (p.cmd.buttons & BT_CUSTOM3) and p.speed <= 0 and P_IsObjectOnGround(p.mo) and not p.hugging and not p.mo.blossom_tornado and not p.mo.blossom_duckdance and not p.tanukisuit and not p.mo.blossom_tanukianim then
		if P_RandomChance(FRACUNIT/100) then
			p.mo.blossom_duckdance = 2
			S_PauseMusic(p)
		else
			p.mo.blossom_duckdance = 1
			P_PlayJingleMusic(p, "HEYYA", nil, true, JT_OTHER)
		end

		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
	end

	if p.mo.blossom_duckdance then
		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.state = S_PLAY_STND
			if p.mo.momz > 0 then p.mo.state = S_PLAY_SPRING end
			if S_SoundPlaying(p.mo, sfx_uigoku) then S_StopSoundByID(p.mo, sfx_uigoku) end
			if p.mo.blossom_duckdance == 2 then S_ResumeMusic(p) end
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		else
			if p.mo.blossom_duckdance == 2 then
				p.mo.state = S_PLAY_CLIMB
				p.mo.sprite2 = SPR2_CLMB
				p.mo.frame = FF_FULLBRIGHT|A

				if not (leveltime%25) then
					local ghost = P_SpawnGhostMobj(p.mo)
					ghost.destscale = 5*FRACUNIT
				end

				if not S_SoundPlaying(p.mo, sfx_uigoku) then S_StartSound(p.mo, sfx_uigoku) end
			else
				if p.mo.state ~= S_PLAY_BLOSSOM_DUCKDANCE then p.mo.state = S_PLAY_BLOSSOM_DUCKDANCE end
			end
		end
	end

	-- Super Form
	if p.powers[pw_super] then
		if not p.mo.blossom_tornadodust2 then p.mo.blossom_tornadodust2 = {} end

		local dust
		local dist = 16
		if not (leveltime%6) then
			local i = P_RandomRange(1, 15)
			dust = P_SpawnMobjFromMobj(p.mo, (dist+10)*cos(p.drawangle+(i*72*ANG1)), (dist+10)*sin(p.drawangle+(i*72*ANG1)), 0, MT_THOK)
			dust.angle = (i*24*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 5*FRACUNIT
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.color = p.mo.color
			dust.colorized = true
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT
			p.mo.blossom_tornadodust2[#p.mo.blossom_tornadodust2+1] = dust
		end

		if not (leveltime%10) then
			dust = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(35, 75)*FRACUNIT, MT_THOK)
			dust.angle = P_RandomRange(1, 360)*ANG1
			dust.momz = -1*FRACUNIT*P_MobjFlip(p.mo)
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.rollangle = P_RandomKey(360)*ANG1
			dust.flags = $|MF_NOCLIP
			dust.color = p.mo.color
			dust.colorized = true
		elseif p.mo.state == S_PLAY_RUN and not (leveltime%2) then
			dust = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-25, 25)*FRACUNIT, P_RandomRange(-25, 25)*FRACUNIT, P_RandomRange(15, 60)*FRACUNIT, MT_THOK)
			dust.angle = P_RandomRange(1, 360)*ANG1
			dust.momz = -1*FRACUNIT*P_MobjFlip(p.mo)
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.rollangle = P_RandomKey(360)*ANG1
			dust.flags = $|MF_NOCLIP
			dust.color = p.mo.color
			dust.colorized = true
		end

		local newtbl = {}
		local rotoffset = 0
		local rotoffset2 = 0
		for i = 1, #p.mo.blossom_tornadodust2 do
			dust = p.mo.blossom_tornadodust2[i]

			if dust and dust.valid then
				if dust.upwardz < 60*FRACUNIT then
					rotoffset = dist+5
					rotoffset2 = dist+8
					P_MoveOrigin(dust, p.mo.x + rotoffset*cos((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.y + rotoffset*sin((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.z + dust.upwardz)
					dust.upwardz = $+FRACUNIT
					dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

					if dust.upwardz >= 25*FRACUNIT then
						dust.momx = p.mo.momx
						dust.momy = p.mo.momy
						dust.momz = p.mo.momz
						dust.tics = 5
						dust.fuse = 5
					end
				end
			end
		end
	-- "bug"
	elseif (not p.mo.targvine) and p.mo.gotovine then 
		if not p.mo.blossom_tornadodust2 then p.mo.blossom_tornadodust2 = {} end

		local dust
		local dist = 16
		if not (leveltime%6) then
			local i = P_RandomRange(1, 15)
			dust = P_SpawnMobjFromMobj(p.mo, (dist+10)*cos(p.drawangle+(i*72*ANG1)), (dist+10)*sin(p.drawangle+(i*72*ANG1)), 0, MT_THOK)
			dust.angle = (i*24*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 5*FRACUNIT
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.color = p.mo.color
			dust.colorized = true
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT
			p.mo.blossom_tornadodust2[#p.mo.blossom_tornadodust2+1] = dust
		end

		local newtbl = {}
		local rotoffset = 0
		local rotoffset2 = 0
		for i = 1, #p.mo.blossom_tornadodust2 do
			dust = p.mo.blossom_tornadodust2[i]

			if dust and dust.valid then
				if dust.upwardz < 60*FRACUNIT then
					rotoffset = dist+5
					rotoffset2 = dist+8
					P_MoveOrigin(dust, p.mo.x + rotoffset*cos((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.y + rotoffset*sin((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.z + dust.upwardz)
					dust.upwardz = $+FRACUNIT
					dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

					if dust.upwardz >= 25*FRACUNIT then
						dust.momx = p.mo.momx
						dust.momy = p.mo.momy
						dust.momz = p.mo.momz
						dust.tics = 5
						dust.fuse = 5
					end
				end
			end
		end
	end
end)

rawset(_G, "Blossom_PostThink", function(p)
	if p.mo.blossom_tanukianim and p.mo.blossom_tanukianim > 1 then
		p.mo.sprite = SPR_DUST
		p.mo.frame = FF_FULLBRIGHT|A
	elseif p.tanukisuit then
		p.mo.sprite = SPR_PLAY
		p.mo.state = S_PLAY_STND
		p.mo.color = SKINCOLOR_SILVER
		p.mo.colorized = true
	end

	if p.mo.skin ~= "blossom" then return end
end)